#ifndef __OPMDRV__
#include <list>
#include "aeffectx.h"
using namespace std;

#define CHMAX 8
#define VOMAX 128

#define ERR_NOERR 0x0000
#define ERR_NOFILE 0x10000000
#define ERR_SYNTAX 0x20000000
#define ERR_LESPRM 0x30000000

#define CHSLOT8 15 //Midi 15Ch assigned OPM8ch

class OPDATA{
	public:
	 //EG-Level
		unsigned int TL;
		unsigned int D1L;
	 //EG-ADR
		unsigned int AR;
		unsigned int D1R;
		unsigned int D2R;
		unsigned int RR;
	 //DeTune
		unsigned int KS;
		unsigned int DT1;
		unsigned int MUL;
		unsigned int DT2;
		unsigned int F_AME;

		OPDATA(void);
};

class CHDATA{
	public:
		unsigned int F_PAN;//L:0x80Msk R:0x40Msk
		unsigned int CON;
		unsigned int FL;
		unsigned int AMS;
		unsigned int PMS;
		unsigned int F_NE;
		unsigned int OpMsk;
		class OPDATA Op[4];
		char Name[16];
		unsigned int SPD;
		unsigned int PMD;
		unsigned int AMD;
		unsigned int WF;
		unsigned int NFQ;
		CHDATA(void);
// ~CHDATA(void);

};


struct TBLMIDICH{
	int VoNum;				//Fԍ 0-
	int Bend;				//sb`xh -8192`+8191[signed 14bit]
	int Vol;				//{[ 0-127
	int Pan;				//L:0x80 Msk,R:0x40 Msk
	int BendRang;			//sb`xhW@1-??[̔{]
	int PMD;
	int AMD;
	int SPD;
	int OpTL[4];			//OpTL̑Εω
	unsigned int RPN;
	unsigned int NRPN;
	bool CuRPN;
	int BfNote;				//Õm[gԍi|^gpj
	int PortaSpeed;			//|^gXs[h
	bool PortaOnOff;
	int LFOdelay;
};





class OPMDRV{
// friend class VOPM;
private:
	unsigned int SampleTime;	//HOSTw肳ꂽDelta
	char CuProgName[64];		//HOSTɑIĂvO
	int CuProgNum;				//HOSTɑIĂvOԍ

	int NoisePrm;				//OPM mCYp[^
	int MstVol;					//}X^[{[
	bool PolyMono;				//Poly true,Mono false
	class Opm *pOPM;
	int OpmClock;				//OPM̃NbN 0:3.58MHz 1:4MHz
//CHǗoXg
	list<int> PlayCh,WaitCh;
	
	struct {
		int VoNum;				//Fԍ0-
		int MidiCh;				//Midi`l
		int Note;				//m[gԍ(0-127,gp255)
		int Vel;				//xVeB
		int PortaBend;			//|^gp̃xhItZbg
		int PortaSpeed;
		int LFOdelayCnt;
	}TblCh[CHMAX];

	struct TBLMIDICH TblMidiCh[16];	//Midi`lݒe[u

	int AtachCh(void);			//`lǉ
	void DelCh(int);			//`l폜
	int ChkEnCh(void);			//󂫃`lԂB
	int ChkSonCh(int,int);		//MidiChƃxVeB蔭̃`lTB
	int NonCh(int,int,int);		//MidiChƃm[gAxVeBŔB
	int NoffCh(int,int);		//MidiChƃm[gŏB

	void SendVo(int);			//Fp[^OPMɑ
	void SendKc(int);			//Kf[^OPMɃZbg
	void SendTl(int);			//`lʂZbg
	void SendPan(int,int);		//PanZbg
	void SendLfo(int);


public:
	OPMDRV(class Opm *);				//RXgN^

	class CHDATA VoTbl[VOMAX];	//Fe[u
															//SLOT 1̐ݒNX
	 	MidiProgramName MidiProg[16];
	void setDelta(unsigned int);						//R}hDeltaԐݒ
	void NoteOn(int Ch,int Note,int Vol);		//m[gnm
	void NoteOff(int Ch,int Note);					//m[gnee
	void NoteAllOff(int Ch);								//Sm[gnee
	void ForceAllOff(int Ch);								//~
	void ForceAllOff();											//~(S`lΉ)
	void BendCng(int Ch,int Bend);					//sb`xhω
	void VolCng(int Ch,int Vol);						//{[ω
	void VoCng(int Ch,int VoNum);						//F`FW
	void MsVolCng(int MVol);								//}X^[{[ω
	void PanCng(int Ch,int Pan);						//Panω
	int Load(char *);												//FALFOݒ胍[h
	int Save(char *);												//FALFOݒZ[u
	int getProgNum(void);										//Fio[擾
	void setProgNum(long );									//Fio[Zbg
	void setProgName(char* );								//FZbg
	char* getProgName(void);								//F擾
	char* getProgName(int);									//F擾
	unsigned char getPrm(int);							//index(Vst kNum)ɂp[^Zbg
	void setPrm(int,unsigned char);					//index(Vst kNum)ɂp[^擾
	void setRPNH(int,int);
	void setNRPNH(int,int);
	void setRPNL(int,int);
	void setNRPNL(int,int);
	void setData(int,int);
	void setPoly(bool);
	void AutoSeq(int sampleframes);
	void setPortaSpeed(int MidiCh,int speed);
	void setPortaOnOff(int MidiCh,bool onoff);
	void setPortaCtr(int MidiCh,int Note);
	void setLFOdelay(int MidiCh,int data);

	~OPMDRV(void);									//fXgN^
	long getMidiProgram(long channel,MidiProgramName *curProg);
	void ChDelay(int );


	void setCcTL_L(int MidiCh,int data,int OpNum);
	void setCcTL_H(int MidiCh,int data,int OpNum);

	void setCcLFQ_L(int MidiCh,int data);
	void setCcLFQ_H(int MidiCh,int data);

	void setCcPMD_L(int MidiCh,int data);
	void setCcPMD_H(int MidiCh,int data);

	void setCcAMD_L(int MidiCh,int data);
	void setCcAMD_H(int MidiCh,int data);

private:
	int CalcLim8(int VoData,int DifData);
	int CalcLim7(int VoData,int DifData);
	int CalcLimTL(int VoData,int DifData);

	void setAMD(int ch,int Amd);
	void setPMD(int ch,int Pmd);
	void setSPD(int ch,int Spd);
	void setTL(int ch,int Tl,int OpNum);
};
#define __OPMDRV__
#endif
